;
;   Moving application Mini Sample by Pavlushin Evgeni for ASCL
;   include bmp image to code and show with macros
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     220000                   ; memory for app
    dd     220000                   ; esp
    dd     0x0 , 0x0               ; I_Param , I_Icon

;******************************************************************************


include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
;step1 converting bmp format to img format for easy out to screen
;      bmp_file_area - offset of bmp load file
;      img_area      - offset of img image
    bmptoimg bmp_file_area,img_area
;step2 out image from img_area
    call draw_window

;Main loop wait for event with 1msec
still:
    timeevent 100,no_event,red,key,button
  no_event:
    mov eax,[xnum]
    add [xstart],eax
    cmp [xstart],799-(209+9+10)
    jna no_right
    mov [xnum],-2
no_right:
    cmp [xstart],1
    jnb no_left
    mov [xnum],2
no_left:

    mov eax,[ynum]
    add [ystart],eax
    cmp [ystart],599-(134+26+10)
    jna no_down
    mov [ynum],-2
no_down:
    cmp [ystart],1
    jnb no_up
    mov [ynum],2
no_up:

    mov eax,67
    mov ebx,[xstart]
    mov ecx,[ystart]
    mov edx,209+9
    mov esi,134+26
    int 0x40

    jmp  still

xstart dd 10
xnum   dd 5
ystart dd 10
ynum   dd 5

;    jmp  still

  red:
    call draw_window
    jmp still

  key:                          ; key
    int  0x40                   ; read (eax=2)
    jmp  still                  ; not testing

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

draw_window:
    startwd
    window 40,40,(209+9),(134+26),window_Skinned+0x00ffffff
    label  12,8,'ASCL SHOW INCLUDE PICTURE',cl_White+font_Big
    setimg 5,22,img_area
    endwd
    ret

; DATA AREA
IM_END:
; For work resrve temp area after file 'pict256.bmp'
bmp_file_area:
file 'pict256.bmp'
rb 30000*4-30000
img_area:
rb 209*134*3+8
I_END:
