; mov [pointer_to_screen],eax
; mov [output_array],ebx
; mov [screen_size_x],ecx
;setpixel (pixel_x,pixel_y)
setpixel:

  mov ecx,[output_array]
  mov eax,[pixel_y]
  mov ebx,[screen_size_x]
  imul eax,ebx
  add eax,[pixel_x]
  lea eax,[eax+eax*2]
  add eax,[pointer_to_screen]
  mov [ecx],eax
  add [output_array],4
  ret

;procedure <<<<calculate line>>>>
; IN
;eax - pointer to screen
;ebx - output array
;ecx - (screen size x)*bytes per pixel
;edx - x1*65536+y1
;esi   x2
;edi - y2
; OUT
;eax - number of pixels
calculate_line:

  mov [pointer_to_screen],eax
  mov [output_array],ebx
  mov [screen_size_x],ecx
  mov eax,edx
  and eax,0xffff
  shr edx,16
  mov [x_l],edx     ;x=x1
  mov [y_l],eax     ;y=y1
  mov [sx],1
  mov [sy],1

  mov edx,[output_array]

  sub esi,[x_l]     ;esi=x2-x1
  jnz no_0_x
  and esi,0
  jmp x_no_minus
  no_0_x:
  jns x_no_minus
  neg esi
  mov [sx],-1	  ;sx=-sx
  x_no_minus:

  sub edi,[y_l]     ;edi=y2-y1
  jnz no_0_y
  and edi,0
  jmp y_no_minus
  no_0_y:
  jns y_no_minus
  neg edi
  mov [sy],-1	  ;sy=-sy
  y_no_minus:

  mov [_dx],esi
  mov [_dy],edi

  cmp [_dx],0	   ;if (dx=0 & dy=0) {  }
  jnz no_null_d
  cmp [_dy],0
  jnz no_null_d
  mov eax,[x_l]
  mov ebx,[y_l]
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel    ;setpixel(x1,y1)
  mov eax,1
  ret
  no_null_d:

  cmp edi,esi	   ;if (dy>dx) {  }
  jle no_bigger
  mov eax,[_dx]
  mov [z],eax	   ;z=dx
  mov eax,[_dy]
  mov [_dx],eax    ;dx=dy
  mov eax,[z]
  mov [_dy],eax    ;dy=z
  mov [_ch],dword 1 ;ch=true
  jmp exit_if2
  no_bigger:	   ;else {}
  and [_ch],0
  exit_if2:

  mov eax,[_dy]
  shl eax,1
  sub eax,[_dx]
  mov [e],eax	 ;e=2*dy-dx

  mov esi,1	 ;counter
  mov edi,[sx]
  mov ebp,[sy]
  do:

     mov eax,[x_l]
     mov ebx,[y_l]
     mov [pixel_x],eax
     mov [pixel_y],ebx
     call setpixel

     cmp [e],0
     js while_e

       mov eax,[_ch]
       test eax,eax
       jz ch_else
       add [x_l],edi
       jmp exit_if3
       ch_else:
       add [y_l],ebp
       exit_if3:

       mov eax,[_dx]
       shl eax,1
       sub [e],eax    ;e=e-2*dx

     while_e:

     mov eax,[_ch]
     test eax,eax
     jz ch_else2
     add [y_l],ebp
     jmp exit_if4
     ch_else2:
     add [x_l],edi
     exit_if4:

     mov eax,[_dy]
     shl eax,1
     add [e],eax ;e=e+2*dy
     inc esi

     mov ecx,[_dx]
     cmp esi,ecx
     jle do	     ;while (i<=dx)

     mov eax,[x_l]
     mov ebx,[y_l]
     mov [pixel_x],eax
     mov [pixel_y],ebx
     call setpixel

     mov eax,[output_array]
     sub eax,edx
     shr eax,2

  ret
;---------------------------
;procedure calculate <<<<<rectangle>>>>>>>
; IN
;eax - pointer to screen
;ebx - output array
;ecx - (screen size x)*bytes per pixel
;edx - x1*65536+y1
;esi   x2
;edi - y2
; OUT
;eax - number of pixels

calculate_rectangle:

  mov [pointer_to_screen],eax
  mov [output_array],ebx
  mov [screen_size_x],ecx
  mov eax,edx
  and eax,0xffff
  shr edx,16
  mov [x_l],edx     ;x=x1
  mov [y_l],eax     ;y=y1
  mov [x2],esi	    ;x2
  mov [y2],edi	    ;y2
  mov [sx],1
  mov [sy],1

  mov edx,[output_array]

  sub esi,[x_l]     ;esi=x2-x1
  jnz no_0_x_r
  and esi,0
  jmp x_no_minus_r
  no_0_x_r:
  jns x_no_minus_r
  neg esi
  mov [sx],-1	  ;sx=-sx
  x_no_minus_r:

  sub edi,[y_l]     ;edi=y2-y1
  jnz no_0_y_r
  and edi,0
  jmp y_no_minus_r
  no_0_y_r:
  jns y_no_minus_r
  neg edi
  mov [sy],-1	  ;sy=-sy
  y_no_minus_r:

  mov [_dx],esi
  mov [_dy],edi

  cmp [_dx],0	   ;if (dx=0 & dy=0) {  }
  jnz no_null_r
  cmp [_dy],0
  jnz no_null_r
  mov eax,[x_l]
  mov ebx,[y_l]
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel    ;setpixel(x1,y1)
  mov eax,1
  ret
  no_null_r:

  mov edi,[_dx]
  mov esi,[x_l]       ;x1

  horizontal_lines:

  mov eax,esi	      ;x
  mov ebx,[y_l]       ;y1
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,esi	      ;x
  mov ebx,[y2]	      ;y2
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  add esi,[sx]
  dec edi
  jns horizontal_lines

  mov edi,[_dy]
  mov esi,[y_l]       ;y1
  vertical_lines:

  mov eax,[x_l]       ;x1
  mov ebx,esi	      ;y
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,[x2]	       ;x2
  mov ebx,esi	       ;y
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  add esi,[sy]
  dec edi
  jns vertical_lines

  mov eax,[output_array]
  sub eax,edx
  shr eax,2

  ret
;procedure <<<<<<calculate_circle>>>>>>
; IN
;eax - pointer to screen
;ebx - output array
;ecx - (screen size x)*bytes per pixel
;edx - x_c*65536+y_c
;esi   r
; OUT
;eax - number of pixels

calculate_circle:

  mov [pointer_to_screen],eax
  mov [output_array],ebx
  mov [screen_size_x],ecx
  mov eax,edx
  and eax,0xffff
  shr edx,16
  mov [x2],edx	   ;circle centr x
  mov [y2],eax	   ;circle centr y
  mov [r],esi	   ;radius of cicrle

  mov edx,[output_array]

  mov [x_l],0	   ;x=0
  mov [y_l],esi    ;y=r
  mov [d],3
  mov eax,[r]
  shl eax,1
  sub [d],eax	   ;d=3-2*r


  while_circle:

  mov esi,[y_l]
  mov edi,[x_l]

  sub esi,edi	   ;while y>=x
  js exit_while_circle


  mov eax,[x_l] ;x
  mov ebx,[y_l] ;y
  add eax,[x2]	;x+xc
  add ebx,[y2]	;y+yc
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,[x_l] ;x
  mov ebx,[y2]	;yc
  add eax,[x2]	;x+xc
  sub ebx,[y_l] ;yc-y
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,[x2]	;xc
  mov ebx,[y2]	;yc
  sub eax,[x_l] ;xc-x
  add ebx,[y_l] ;yc+y
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,[x2]	;xc
  mov ebx,[y2]	;yc
  sub eax,[x_l] ;xc-x
  sub ebx,[y_l] ;yc-y
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,[x2]	;xc
  mov ebx,[y2]	;yc
  add eax,[y_l] ;xc+y
  add ebx,[x_l] ;yc+x
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,[x2]	;xc
  mov ebx,[y2]	;yc
  add eax,[y_l] ;xc+y
  sub ebx,[x_l] ;yc-x
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,[x2]	;xc
  mov ebx,[y2]	;yc
  sub eax,[y_l] ;xc-y
  add ebx,[x_l] ;x+yc
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  mov eax,[x2]	;xc
  mov ebx,[y2]	;yc
  sub eax,[y_l] ;xc-y
  sub ebx,[x_l] ;yc-x
  mov [pixel_x],eax
  mov [pixel_y],ebx
  call setpixel

  cmp [d],0
  jns if1_d
  mov eax,[x_l]
  shl eax,2
  add eax,6
  add [d],eax  ;d=d+4*x+6
  jmp exit_if1_d
  if1_d:
  mov eax,[x_l]
  sub eax,[y_l]
  shl eax,2
  add eax,10
  add [d],eax	 ;d=d+4*(x-y)+10
  dec [y_l]
  exit_if1_d:
  inc [x_l]

  jmp while_circle

  exit_while_circle:

  mov eax,[output_array]
  sub eax,edx
  shr eax,2

  ret
;---------------------------
  x_l dd ?
  y_l dd ?
  _dx dd ?
  _dy dd ?
  sx  dd ?
  sy  dd ?
  z   dd ?
  e   dd ?
  i   dd ?
  _ch dd ?
  x2  dd ?
  y2  dd ?
  d   dd ?
  r   dd ?
;---------------------------
pointer_to_screen      dd 0
screen_size_x	       dd 0
output_array	       dd 0
pixel_x 	       dd 0
pixel_y 	       dd 0